use thiserror::Error;
#[derive(Debug, Error)]
pub enum Error {
    #[error("Version range includes no version")]
    SingleVersionNotInclusive,
    #[error("Version range is missing ] or )")]
    UnboundRange,
    #[error("Lower version ist higher than upper version")]
    IllegalBound,
    #[error("Version range syntax error")]
    IllegalVersionRange,
    #[error("Version range overlap")]
    RangeOverlap,
    #[error("Version contains invalid characters")]
    InvalidVersion,
    #[error("SemVer error: {0}")]
    Semver(#[from] semver::Error),
}
pub type Result<T> = std::result::Result<T, Error>;
