//Simple implementation for substring of a String
pub trait StringTools {
    fn substring(&self, start: usize, end: usize) -> String;
    fn index_of(&self, c: char) -> Option<usize>;
    fn length(&self) -> usize;
}
impl StringTools for String {
    fn substring(&self, start: usize, end: usize) -> String {
        let substring = &self[start..end];
        substring.to_string()
    }
    fn index_of(&self, c: char) -> Option<usize> {
        self.chars().position(|ch| ch == c)
    }
    fn length(&self) -> usize {
        self.chars().count()
    }
}
